{$M $4000,0,0}
program P_VGA_VESA;
{Created by S.Simeonoff (c) 03.09.1996(V1.0), The town of Lyascovetz}
{This program is dedicated to lovely... It's no use...}
{Just enjoy if you can!}

{It happened so long time ago. Now I'm on vacantion. Today is April,4,1997
  Again sores bleed. But this time I'll try to complete the program...
  Sure... So many things have happened since... I'm just a dull jerk.
  Never more, Never again, Never Mind... What?}
{Second release (the last day of the vacantion - 13.04.97
  is created (of course) by SSS(the Waster)}

uses PT_Init;
const
  length=2057;
  name:array [0..12] of char='image000.bmp'+#0; {Null terminated string}
var
  Buf:array [0..length] of byte;
  Handler:word;    {Handler for file DOS2.0+}
  CRTC:word;       {CRTC index - 3d4h(color), 3b4h(mono)}
  SavMode:byte;    {last used read and write mode}
  SavPlane:byte;   {last used plane number}
  SavCRTCInd:byte; {store CRTC index}
  SavSerInd:byte;  {store Serial contr. index}
  SavGraphInd:byte;{store Graph. contr. index}

  LineSize:word;   {legth of a line in VRAM}
  MaxX:word;       {Weight+1}
  MaxY:word;       {Height}
  LineCompare:word;{last line for normal access, next is at a000:0000}
  Ofset:word;      {Offset in VRAM (CRTC reg0Ch:reg0Dh)}
  ColorBits:byte;  {bits per a pixel}
  NotChain4:byte;  {shows activity of mode Chain4(320x200 256colors}
  NotFail:byte;    {'Detect' sets this flag to 0 if mode isn't support}

  SetP:pointer;  {a procedure that changes current page}
  SizeW:word;    {Size of VESA windows, should be 64}
  GranW:word;    {Granul. of VESA windows, no default}
  LastPage:word; {last used page before poping-up the program}
  LstP:word;
  VESAFlag:byte; {indacates VESA standarts}
                 {bit0 - set if VESA is detected}
                 {bit1 - set if VESA1.1+}
  LogLenFlag:byte;{indicates int10 ax=4f06 bx=00 has been called}

  CurPage:word;  {current page}
  Granul:word;   {for switch 64k}
  StartAddr:longint; {real offset from $a000 if VESA1.1+}
  LogLength:word;{logical LineSize per bytes}

  Active:byte;    {if it's 1 program is saving the image}
  MadeActive:byte;  {consider using int50h}
  Handler13h:pointer; {Old 13h vector}
  Handler10h:pointer; {Old 10h vector}
  Handler2fh:pointer; {Old 2fh vector}
  Handler28h:pointer; {Old 28h vector}
  In13h:byte;        {increased every time when int13 is being called}
  In10h:byte;        {increased every time when int10 is being called}
  In28h:byte;        {increased every time when int28 is being called}
  PInDos:^word;      {InDos is only a byte but the previous byte indicates
                     if a critical error has occured, so using word is great}

  RelocIRQ:byte;
  P50h:pointer;     {Old Handlers}
  P51h:pointer;     {the order of handlers}
  P52h:pointer;     {must stay the same!}
  P53h:pointer;
  P54h:pointer;
  P55h:pointer;
  P56h:pointer;
  P57h:pointer;

  ParamLine:word;  {bit0-request for uninstalling,
                    bit1-no souund request
                    bit2-set if LIM/EMS driver is detected
                    bit8-15 relocated IRQ}
  PSP:word;        {program PSP}
  EOD:word absolute PSP;{End Of Data}
  EOP:word;

{$F-}
{$S-}
{$I-}

procedure S_DS;assembler; {this isn't a procedure, only takes }
asm nop end;              {2 bytes at CS:0 (nop;retn), used to store}
                          {relocated program data segment}
procedure Keep(ErrCode:byte);forward;

procedure CopyIt;assembler;
asm
  rep movsw
  mov ds,bx            {and set DS to the new data segment}

  push cx  {push 0}
  call keep            {then stay resident}


end;

procedure SetIRQ(IRQ0:byte);assembler;{set hardware IRQs to begin at IRQ0}
asm
  cli        {disable interrupts}
  in al,21h  {Get IMR}
  push ax    {Store it}

  mov al,11h
  out 20h,al
  jmp @w1
 @w1:
  mov al,IRQ0 {number of the first interrupt}
  out 21h,al
  jmp @w2
 @w2:
  mov al,$4  {ICW3 use slave 8259}
  out 21h,al
  jmp @w3
 @w3:
  mov al,1   {8086/8088 mode}
  out 21h,al

  xor cx,cx
  @here:
  loop @here  {waste time to recover port 21h}
  pop ax
  out 21h,al  {Restore IMR}

  test ParamLine,100b  {bit2 is set if LIM/EMS is found}
  je @NO_EMS

  mov ax,0de0ah        {get the bases of IRQs}
  int 67h
  mov ax,0de0bh
  xor bh,bh
  mov bl,IRQ0         {and set IRQ0-7 to a new base}
  int 67h
  @NO_EMS:
  sti         {enable interrupts}
end;

procedure SetIntVec(Number:byte;Address:pointer);assembler;
asm
  mov ah,25h        {set int. vector DOS1.0+}
  mov al,Number     {the number of the vector}
  push ds
  lds dx,Address    {DS:DX-address of new interrupt}
  int 21h
  pop ds
end;
procedure GetIntVec(Number:byte;var Handler:pointer);assembler;
asm
  mov ah,35h      {Get int. vector DOS2.0+}
  mov al,Number   {the number of the interrupt}
  int 21h
  mov ax,es       {store ES because ES:BX is pointer for that interrupt}
  les di,Handler
  mov es:[di],bx  {store offset}
  mov es:[di+2],ax{store segment}
end;
procedure Keep(ErrCode:byte);assembler;
asm
  mov ah,51h            {Get PSP  Segment}
  int 21h               {                }
  mov PSP,bx
  push ds               {store Data Segment}

  mov ds,bx
  mov es,[2ch]          {                }
  mov ah,49h            {and free it     }
  int 21h

  mov ah,31h            {TSR function of int21h}
  mov al,ErrCode
  mov bx,cs

  pop dx                {get Data Segment}
  mov cx,offset EOD     {DX:CX - end of data segment}
  shr cx,4
  add dx,cx
  add dx,17   {perhaps there is a need of 256bytes more(?)}
  sub dx,bx
  int 21h     {GO TSR}
end;
function DoUninstall:byte;forward;

procedure GetLine16(Offs:word);assembler;
asm
  mov ax,0a000h    {segment in VIDEO memory}
  mov es,ax
  mov word ptr @plane,3 {start with plane 4(3) down to 1(0)}


  @next_plane:
  mov ax,word ptr @plane
  mov ah,al              {in ah is number of the plane}
  mov al,4               {put plane in Reg4}
  mov dx,3ceh
  out dx,ax
  mov si,Offs           {Set SI to offset of line}
  mov di,offset Buf     {DI is initialize with buffer}
  cmp VESAFlag,0
  je @NoChange

  mov ax,4f05h          {reset page}
  xor bx,bx
  mov dx,CurPage
  int 10h

  @NoChange:
  mov cx,LineSize

  @next_byte:
  mov al, es:[si]
  push si {save offset in VIDEO RAM}
  mov bl,4 {there are 8 bits in every byte (4*2=8)}

  @2_bits:

  mov bh,[di]
  shl al,1
  jnc @zero1              {if bit is 0-nothing}
  mov si,word ptr @plane  {in SI is offset of mask for 1st tetrada}
  or bh,cs:[si+offset @table]           {update bh}
  @zero1:

  shl al,1
  jnc @zero2
  mov si,word ptr @plane  {in SI is offset of mask for 2nd tetrada}
  or bh,cs:[si+offset @table2]           {update bh}
  @zero2:

  mov [di],bh             {now update Buffer}
  inc di                  {increament offset for Buf}

  dec bl
  jne @2_bits

  pop si                  {restore offset in VIDEO RAM}
  inc si
  jne @no_turn

  mov ax,4f05h          {sets new Page}
  xor bx,bx
  mov dx,CurPage
  add dx,Granul
  mov CurPage,dx
  int 10h

  @no_turn:
  loop @next_byte

  dec word ptr @plane     {next plane}
  jns @next_plane
  js @exit                {instead ofjmp}

  @table2:db 01,02,04,08
  @table:db 10h,20h,40h,80h
  @plane:dw 0
  @exit:
end;{GetLine16}

procedure ClearBuf;assembler;
asm
  push ds
  pop es                {set ES to DS for stosw}
  xor ax,ax             {clear AX}
  mov di,offset buf     {begin at ES:DI}
  mov cx,length/2       {length in words}
  rep stosw             {clear the whole buffer}
end;

function CreateFile:boolean;assembler;
asm
  mov ah,3ch {creat file}
  mov dx,offset name
  mov cx,100000b
  int 21h
  mov word ptr Handler,ax
  mov al,true
  jnc @exit
  mov al,false
  @exit:    {if any error has occured result is false else Hanler is correct}
end;


procedure CloseFile;assembler;
asm
  mov ah,3eh    {close file}
  mov bx,Handler
  int 21h
end;

function WriteFile(Len:word):boolean;assembler;
asm
  mov cx,Len
  mov ah,40h    {write bytes}
  mov dx,offset Buf
  mov bx,Handler
  int 21h
  mov al,true
  jnc @exit
  mov al,false {if any error - result is false}
  @exit:
end;

procedure MakeHeader;assembler;
asm
  mov ax,MaxX
  mov word ptr @Wight,ax
  mov bx,MaxY
  inc bx
  mov word ptr @Height,bx {save X and Y}

  mul bx                  {calculate Bitmap Size}
  mov di,256              {di contents number of colors in pallet}
  mov cl,ColorBits
  cmp cl,8                {is 256colors}
  je  @SetClrBits         {yes, no correction}

  cmp cl,4                {is 16color}
  jne @24Bits             {no goto 24bits}
  shr dx,1                {yes, correct divide by 2}
  rcr ax,1
  mov di,16               {in di is the number of colors in palette}
  jmp @SetClrBits

  @24bits: {not only 24bits.16 and 15 bits images are RGB, too}
  mov si,ax               {store ax in si for sum}
  mov bx,dx               {store dx in bx for sum}
  shl ax,1                {mul dx:ax }
  rcl dx,1                {by 2}
  add ax,si               {sum dx:ax }
  adc dx,bx               {with bx:si (a*2+a=3a)}
  xor di,di               {pallet is empty}
  mov cl,24               {RGB type}

  @SetClrBits:
  mov byte ptr @BitClr,cl
  mov word ptr @SizeImg,ax
  mov word ptr @SizeImg+2,dx
  shl di,1  {4 bytes descire a color}
  shl di,1
  add di,54  {add to di size of headers,54 bytes}
  mov word ptr @OffsBits,di  {set OffsBits}
  add ax,di
  adc dx,0      {sum di  with dx:ax}
  mov word ptr @Size,ax
  mov word ptr @Size+2,dx
  jmp @exit    {flag c=0, may use jc @exit}


  @FileHeader:
    @Type:db 'BM'
    @Size:dd 0
    @res1:dw 0,0
    @OffsBits:dd 0
  @InfoHeader:
    @biSIze:dd 40
    @Wight:dd 0
    @Height:dd 0
    @Planes:dw 1
    @BitClr:dw 0
    @Compreesion:dd 0
    @SizeImg:dd 0
    @X_per_M:dd 0
    @Y_per_M:dd 0
    @ColorsUsed:dd 0
    @ColorsImportat:dd 0 {length of headers is 54 bytes}
  @exit:

  mov di,offset Buf
  mov bx,ds     {store DS}
  mov es,bx     {set ES to DS}
  push cs       {set DS to CS}
  pop  ds
  mov si,offset @FileHeader
  mov cx,54/2   {copy 54/2 words}
  rep movsw
  mov ds,bx     {restore DS}
end;

procedure NextName;assembler;
asm
  mov ax,word ptr[name+6]{get last two numbers al-2nd ah-3rd}
  sub ax,3030h           {correct ax for BCD}
  xchg ah,al             {now in al is 3rd, in ah is 2nd}
  inc ax                 {increase number, last 2 numbers}
  aaa                    {correcrion}
  cmp ax,0a00h           {100?}
  jne @set_number
  inc byte ptr [name+5]  {increse  the first number}
  xor ax,ax              {last 2 ones set to zero}

  @set_number:
  xchg ah,al             {now al-2nd,ah-3rd}
  add ax,3030h           {correct ax for ASCII}
  mov word ptr [name+6],ax {refresh numbers}
end; {nextname}

procedure GetColors16;assembler;
asm
  mov ax,1009h {function reads}
  push ds      {palette and overscan reg}
  pop es       {at ES:DX}
  mov dx,offset Buf+100h
  int 10h
  mov dl,11000000b {DL is mask and flag}
  mov ax,101Ah  {function returns in bl(bit 7) the method for selecting colors}
  int 10h       {and BH is set with Color Selet, (reg 14, attrib contr.)}
  and bl,7fh    {check for mode}
  jne @4x64     {is 16x16?}
  mov dl,11110000b {yes, correct DL}
  @4x64:
  shl bh,4          {shift ColorSelect 4 times}
  and bh,dl         {mask it, depending on method}
  mov byte ptr @mask,bh {for Select Colors and save it}
  xor dl,11001111b {DL is use for mask of lines A4,A5}

  xor si,si  {set to zero}
  xor di,di  {the counters}
  xor bh,bh
  @loop:
  mov bl,byte ptr Buf[100h+si]
  and bl,dl {nul or do nothing with lines A4,A5}
  or bl,byte ptr @mask  {copy line A6 and A7}
  mov ax,1015h  {function}
  int 10h     {gets colors CL-blue CH-green  DH-reg}
  mov al,cl   {store cl in al}
  mov cl,2    {only bit 0-5 are used }
  shl al,cl   {in DAC}
  shl ch,cl   {so mul values}
  shl dh,cl   {by 4(shift 2 position left)}
  mov byte ptr Buf[di],al     {save colors}
  mov byte ptr Buf[di+1],ch   {in Buf}
  mov byte ptr Buf[di+2],dh
  add di,4    {there is one more byte but it's unused}
  inc si      {increase counter}
  cmp si,16   {reach the end?}
  jne @loop   {no, loop}
  @exit:
  ret

  @mask:      {Pascal adds a instruction ret so the necessary place
                   is already allocated }
end;{GetColors16}

procedure GetColors256;assembler;
asm
  mov ax,1017h               {function reads}
  xor bx,bx                  {a block of color regs}
  mov cx,100h{ffh}           {first is in BX}
  mov dx,offset Buf+400h     {count - in cx}
  push ds
  pop es
(*  push ds   {posible witout these}
  { PUSH DX is so wrong}
  pop es                     {2 instructions}*)
(*first instsruction fucked my hard with 30 or more MBytes!Damn it!*)
  int 10h                    {buffer es:di}
  mov cl,2
{  xor bl,bl}
  xor si,si
  xor di,di
  @loop:                  {reordering bytes}
  mov ax,word ptr [offset Buf+400h+si]
  mov dl,byte  [offset Buf+400h+si+2]
  shl ax,cl
  shl dl,cl
  xchg ah,al
  mov byte ptr [Buf+di],dl
  mov word ptr [Buf+di+1],ax
  add si,3
  add di,4
  dec bl
  jne @loop
end;

procedure SaveInd;assembler;
asm
  mov dx,3ceh              {graph. controller}
  in al,dx                 {store graph. index}
  mov SavGraphInd,al
  mov dx,CRTC              {Store CRTC index}
  in al,dx
  mov SavCRTCInd,al
  mov dx,3c4h              {store serial contr.index}
  in al,dx
  mov SavSerInd,al
end; {SaveInd}


procedure RestoreInd;assembler;
asm
  mov dx,3ceh   {graph. contr}
  mov al,SavGraphInd
  out dx,al
  mov dx,CRTC
  mov al,SavCRTCInd
  out dx,al
  mov dx,3c4h   {Serial}
  mov al,SavSerInd
  out dx,al
end;{RestoreInd}

procedure SaveStatus;assembler;
asm
  mov dx,3ceh              {graph. contr}
  mov al,5                 {save readmode}
  out dx,al
  inc dx
  in al,dx
  mov SavMode,al           {in savmode}
  and al,11110111b         {set readmode 0}
  out dx,al
  dec dx
  mov al,4                 {save last used plane}
  out dx,al                {number}
  inc dx
  in al,dx
  mov SavPlane,al
  cmp VESAFlag,0
  je @exit

  mov ax,4f05h             {store last page }
  mov bx,0100h             {in VESA modes}
  int 10h
  shl ah,7                 {if ah=01fh the function}
  or dh,ah                 {has failed}
  mov LastPage,dx          {so bit 15 of dx is set}


 @exit:
end;

procedure RestoreStatus;assembler;
asm
  mov dx,3ceh      {restore readmode}
  mov ah,SavMode
  mov al,5
  out dx,ax
  mov ah,SavPlane  {and last used plane number}
  dec al
  out dx,ax
  cmp VESAFlag,0
  je @exit

  mov ax,4f05h
  xor bx,bx
  mov dx,LastPage       {and VESA Page}
  or dh,dh
  js @exit              {if bit15 of dx is set, LastPage is not correct}
  int 10h
  @exit:
end;{RestoreStatus}

procedure GetLinePages320(Offs:word);assembler;
asm
  mov ax,0A000h
  mov es,ax
  mov si,3                   {SI is counter for plane}
  mov dx,03ceh               {potr for graphic controler}

  @lp:
  mov di,word ptr offs
  mov ax,si
  mov ah,al
  mov al,4                    {plane select register}
  out dx,ax
  mov bx,offset Buf

  mov cx,LineSize             {length of the line}
  @plane:
  mov al,es:[di]
  mov [si+bx],al
  inc di
  add bx,4
  loop @plane
  dec si
  jns @lp
end;{GetLinePages320}

procedure GetLineChain4(Line:word);assembler;
asm
  mov ax,Line
  mov cx,320    {LineSize}
  mul cx
  mov bx,ds     {store ds}
  mov es,bx     {set es to DS for MOSB}
  mov di,offset Buf
  mov si,ax     {in SI is offset in $A000}
  mov ax,$a000  {just copy 320 bytes from $A000:SI}
  mov ds,ax     {to Buf}
  rep movsb
  mov ds,bx     {restore ds}
end;

procedure GetCRTC;assembler;
asm
  mov di,18h
  @ReadCRTC:
  mov ax,di         {in al is the index}
  mov dx,CRTC
  out dx,al
  inc dx            {CRTC data}
  in al,dx
  mov byte ptr Buf [di],al     {copy first 18h regs of CRTC to Buf}
  dec di
  jns @ReadCRTC

  mov ax,word ptr Buf[0ch] {get offset from graph.page}
  xchg ah,al
  mov word ptr Ofset,ax {store it}

  xor ah,ah
  mov al,byte ptr Buf [18h]   {line compare}
  mov bl,byte ptr Buf [7]     {overflow}
  test bl,00010000b           {bit4 is bit8 of LineCompare(index18h)}
  je @zero_bit8
  inc ah                      {set ah bit1}
  @zero_bit8:
  mov cl,byte ptr Buf [9]     {max scan line}
  test cl,01000000b           {bit6 of that reg is bit9 of LineCompare}
  je @zero_bit9
  or ah,2                    {set ah bit2}
  @zero_bit9:
  or cl,cl                   {Bit7 indicates line}
  jns @nodub                 {flag s=bit7 of index9 of CRTC}
  mov cl,1                   {set cl to 1 for shr operarion}
  @nodub:
  and cl,1                   {if line dubbing}
  shr ax,cl                  {div LineCompare}
  mov LineCompare,ax         {store LineCompare}

  cmp MaxY,598                {if more than 600 lines}
  ja @VESA1_1                 {next instruction should never(?) be executed}
  {Advanced detection of MaxY}
  mov al,byte ptr Buf [15h]   {start vertical blanking(real MaxY+2)}
  xor ah,ah
  test bl,00001000b          {bl is still overflow reg}
  je @null_bit8              {bit3 of overflow reg. is bit8 of reg12}
  inc ah
  @null_bit8:
  test dl,00100000b      {bit5 of max scan line is bit9 of start v. blanking}
  je @Store_Blanking
  or ah,2
  @Store_Blanking:
  shr ax,cl                    {cl is flag that shows lines to be double}
  dec ax

  xor dh,dh
  mov dl,byte ptr Buf [12h]{Vertical display end}
  test bl,00000010b        {bl is still overflow reg}
  je @z_b8
  inc dh                    {bit8}
  @z_b8:
  test bl,01000000b
  je @Store_MaxY
  or dh,2                   {bit9}
  @Store_MaxY:
  shr dx,cl
  cmp ax,dx   {in ax or dx is real MaxY}
  jna @SaveIt {the less value}
  mov ax,dx   {is neccessary}
  @Saveit: mov MaxY,ax

  mov ax,word ptr Buf [13h] {offset reg. (Logical scan length)}
  {in al is logical scan length but it needs some correction}
  {depending on mode (byte,word or DWord}
  and ah,01000000b {in ah is Underline reg bit6,if set-DWord mode}
  {should not use TEST (using AND nulls ah)}
  je @noDoubleWord    {no}
  shl ax,3   {yes, must mul by 8 scanlegth}
  jmp @StoreScanLine
  @noDoubleWord:
  mov bl,byte ptr Buf [17h] {mode control reg}
  test bl,01000000b         {if bit6 is set-byte mode is active else word mode}
  jne @noWord               {yes,go for byte}
  shl ax,2
  jmp @StoreScanLine
  @noWord:
  shl ax,1     {the mode isn't DWord nor word, shoud be byte}
  jmp @StoreScanLine
(*  @StoreScanLine:
  mov LogLength,ax {store logical length in bytes}
*)
  @VESA1_1:
  cmp LogLength,0
  jne @exit
  mov ax,LineSize

  @StoreScanLine:
  mov LogLength,ax {store logical length in bytes}
  @exit:
end;{GetOffset}

procedure Detect;assembler;
asm
  cli

  mov byte ptr NotFail,0
  mov dx,3ceh
  mov al,6
  out dx,al   {testing mode}
  inc dx
  in al,dx
  shr al,1    {bit0- if clear - mode is text else graph}
  jnc @exit

  mov byte ptr VESAFlag,0    {testing VESA}
  mov byte ptr NotChain4,1
  mov ax,4f00h
  mov di,offset Buf
  push ds
  pop es
  int 10h  {is installed VESA}
  cmp ax,004fh
  jne @VGA

  inc byte ptr VESAFlag  {yes, set the flag}
  mov ax,4f03h           {get current video mode}
  int 10h
  xor si,si              {nul counter}
  cmp bx,6ah
  jne @nocorrect
  mov bx,102h           {mode 6ah is the same as 102h}
  @nocorrect:           {other mode}
  @SearchMode:
  mov ax,word ptr @SupportVESA+si
  cmp bx,ax             {Is the mode supported by the program?}
  je @found_it          {yes, go out}
  or ax,ax              {no. Is this the end?}
  je @VGAgoto           {yes, go and look for VGA}
  add si,7              {no, next mode}
  jne @SearchMode

  @found_it:
  mov ax,word ptr @SupportVESA+SI+2     {Set}
  mov MaxX,ax                           {MaxX with X resolution+1}
  mov ax,word ptr @SupportVESA+SI+4     {set}
  mov MaxY,ax                           {MaxY with y res}
  mov dl,byte ptr @SupportVESA+SI+6     {set Bits used }
  mov ColorBits,dl                      {for 1 pixel}
  mov ax,4f01h                          {Read pointer}
  mov cx,bx                             {for procedure}
  mov di,offset Buf                     {that changes}
  int 10h                               {the reading window}
  mov ax,word ptr Buf[0ch]              {get pointer, 1st byte}
  mov word ptr SetP,ax                  {save it}
  mov ax,word ptr Buf[0eh]              {get pointer, 2st byte}
  mov word ptr SetP+2,ax                {save it}
  mov bx,word ptr Buf[4]                {get granul.}
  mov GranW,bx                          {save it.}
  mov ax,64                             {div 64 by Granw}
  div bl                                {this const. is used for}
  mov Granul,ax                         {switching 64KB }
  mov ax,word ptr Buf[6]                {get size}
  mov SizeW,ax                          {save it}

  inc NotFail                           {Mode is detected}
  jmp @SetLineSize                      {set size}


  @VGA:
  mov ah,0fh  {if not VESA use VGA BIOS}
  int 10h
  mov bl,al   {if caller is VESA detection}
  @VGAgoto:   {this save a little time}
  mov VESAFlag,0 {and the other procedures work correctly}
  cmp bl,13
  jne @no13
  mov MaxX,320  {320x200 16clr}
  mov MaxY,199
  je  @16c
  @no13:
  cmp bl,0eh
  jne @no0eh
  mov MaxY,199
  je @Set640
  @no0eh:
  cmp bl,12h  {mode 12h,640x480 16 colors}
  jne @no12h
  mov MaxY,479
  je  @Set640 {instead of jmp, set other arguments}

  @no12h:    {mode isn't 12h}
  cmp bl,10h {mode 10h,640x350 16 color}
  jne @no10h
  mov MaxY,349
  @Set640:
  mov MaxX,640
  @16c:
  mov ColorBits,4
  inc NotFail
  jmp @SetLineSize

  @no10h:   {mode isn't 10h nor 12h nor 0eh}
  cmp bl,13h
  jne @exit  {if not 13h go to exit}
  mov cx,199 {in CX is the number of lines}
  mov dx,3c4h{testing Chain4, dx-serial contr.}
  mov al,4
  out dx,al
  inc dx     {dx is data}
  in al,dx   {bit3 shows Chain4(1-enabled)}
  and al,00001000b
  je @noChain4
  mov NotChain4,0
  jne @Set320


  @noChain4:
  mov dx,CRTC
  mov al,9
  out dx,al
  inc dx      {CRTC data}
  in al,dx
  and al,1h   {bit 1{0-enabled)}
  jne @noDub
  add cx,200  {cx=399}
  @noDub:

  @Set320:
  inc NotFail
  mov MaxY,cx
  mov ax,320    {Real LineSize in bytes}
  mov MaxX,ax
  mov ColorBits,8
  mov cl,NotChain4
  shl cl,1      {set cl to 2 if the mode isn't Chain4}
  jmp @SetSize  {instead(jnc) jmp}

   @SupportVESA:
   dw 102h      {800x600 16 colors (mode X resolution,Y res, bitcolors)}
      dw 800,599{mode $6a is the same}
      db 4
   dw 150h      {640x350 16 color}
      dw 640,349
      db 4

   dw 104h      {1024x768 16 color}
      dw 1024,767
      db 4
   dw 106h      {1280x1024 16 color}
      dw 1280,1023
      db 4
   dw 123h      {1600x1200 16 color}
      dw 1600,1199
      db 4
   dw 11ch      {640x350 256 color}
      dw 640,349
      db 8
   dw 100h      {640x400 256 color}
      dw 640,399
      db 8
   dw 101h      {640x480 256 color}
      dw 640,479
      db 8
   dw 103h      {800x600 256 color}
      dw 800,599
      db 8
   dw 105h      {1024x768 256 color}
      dw 1024,767
      db 8
   dw 11eh      {640x400 32k color}
      dw 640,399
      db 15
   dw 11dh       {640x350 32k color}
      dw 640,349
      db 15
   dw 110h       {640x480 32k color}
      dw 640,479
      db 15
   dw 113h       {800x600 32k color}
      dw 800,599
      db 15
   dw 116h       {1024x768 32k color}
      dw 1024,767
      db 15
   dw 119h       {1280x1024 32k color}
      dw 1280,1023
      db 15
   dw 125h       {1600x1200 32k color}
      dw 1600,1199
      db 15
   dw 10eh       {320x200 64k color}
      dw 320,199
      db 15
   dw 11fh       {640x350 64k color}
      dw 640,349
      db 16
   dw 120h       {640x400 64k color}
      dw 640,399
      db 16
   dw 111h       {640x480 64k color}
      dw 640,479
      db 16
   dw 114h       {800x600 64k color}
      dw 800,599
      db 16
   dw 117h       {1024x768 64k color}
      dw 1024,767
      db 16
   dw 11ah       {1280x1024 64k color}
      dw 1280,1023
      db 16
   dw 126h       {1600x1200 64k color}
      dw 1600,1199
      db 16
   dw 10fh       {320x200 True Color}
      dw 320,199
      db 24
   dw 121h       {640x350 True Color}
      dw 640,349
      db 24
   dw 122h       {640x400 True Color}
      dw 640,399
      db 24
   dw 112h       {640x480 True Color}
      dw 640,479
      db 24
   dw 115h       {800x600 True Color}
      dw 800,599
      db 24
   dw 118h       {1024x768 True Color}
      dw 1024,767
      db 24
   dw 11bh       {1280x1024 True Color}
      dw 1024,1023
      db 24
   dw 127h       {1600x1200 True Color}
      dw 1600,1199
      db 24
   dw 0  {end}


  @SetLineSize:
  mov cl,3
  mov ax,MaxX
  mov bl,ColorBits
  xor bh,bh
  cmp bl,4
  je @SetSize     {if mode is 16color just div by 8}
  cmp bl,15
  jne @nocor
  inc bl
  @nocor:
  mul bx        {if mode is more than 16c first mul it with bits per a pel}
  @SetSize:
  shr ax,cl     {and Chain4 is disabled (or in 16colors)}
  mov LineSize,ax

  @exit:
  sti
end;

procedure GetVESALine(Ofst:word;PixelToGet:word);assembler;
asm
  mov ax,0a000h
  mov es,ax {set es to VRAM}

  mov bx,Ofst        {set bx to offset }
  xor di,di          {id is counter}
  mov si,di
  mov dl,al          {dl is counter for number of byte(dl=0)}

  @loop:
  mov cx,3

  mov al,es:[bx]     {read byte }
  cmp ColorBits,24
  je @noconv
  cmp ColorBits,8
  je @noconv
  or dl,dl           {convert 15bits to 24}
  jne @2nd
  xor ah,ah
  shl ax,cl
  inc dl             {next time second byte}
  jne @store         {instead of jmp}

  @2nd:              {in AH are last 3 bits of green(2nd byte)}
  mov ch,al
  cmp ColorBits,15
  je @B15
  and ch,00000111b   {first 3 bits are in ch if the mode is in 65536 colors}
  and al,11111000b   {in al is red component}
  shl ch,1
  dec cl             {cl=2 }
  jmp @common15_16
  @B15:
  and ch,00000011b   {first 2 bits are in ch if the mode is in 32768 colors}
  and al,01111100b   {in al is red component}
  shl al,1           {need to correct red component in 15bits mode}
  @common15_16:
  shl ch,cl          {common part for hi color modes}
  or ch,ah           {in CH is green}
  shl ch,cl
  mov byte ptr Buf[si],ch
  inc si
  dec dl             {dl=0}

  @noconv:
  @store:
  mov byte ptr Buf [si],al  {store it}
  inc si
  inc bx                    {increase offset}
  jne @ThisPage             {end of page? No, skip that}

  push dx
  push ax
  mov dx,CurPage {yes, increase current page}
  add dx,Granul  {add granul for switching}
  mov CurPage,dx {with 64Kb pages}
  mov ax,4f05h   {switch it}
  int 10h
  xor bx,bx      {BX should be zero}
  pop ax
  pop dx

  @ThisPage:              {next byte}
  inc di
  cmp di,PixelToGet
  jne @loop
end;


function Set_Offset_And_Page(Line:word):word;assembler;
asm
  xor dx,dx
  mov bx,Granul

  mov ax,LogLength
  mul Line       {in DX:AX is offset from $a000}
  cmp VESAFlag,0 {is this a VESA mode?}
  je @exit       {no, go out}
  add ax,word ptr StartAddr
  adc dx,word ptr StartAddr+2
  mov cx,ax {Yes,countinue}
  mov ax,dx
  mul bx
  mov dx,ax

  cmp dx,CurPage
  je @skip
  mov CurPage,dx
  mov ax,4f05h
  xor bx,bx
  int 10h
  @skip:
  mov ax,cx
  @exit:
end;

procedure GetLogScan;assembler;
asm
  cmp LogLenFlag,0
  je @null

  mov ax,4f06h  {get logical scan legth}
  mov bx,1
  int 10h
  cmp ax,004fh  {is function supported}
  jne @null      {no, go out}
  or VESAFlag,2  {set bit 1 in VESAFlag, indicated v1.1+}
  mov LogLength,bx   {yes, store scan line length}
  mov bx,1
  mov ax,4f07h  {get display start}
  int 10h
  cmp ax,004fh   {is function supported?}
  jne @null      {No! go out}
  mov ax,LogLength      {calculate starting address}
  mul dx
  push dx
  xchg ax,cx
  mul LineSize           {that's a way to find the bytes per a pixel}
  div MaxX               {slow but in a few bytes}
  pop dx
  add ax,cx
  adc dx,0
  jmp @exit

  @null:
  xor ax,ax
  mov dx,ax
  mov LogLength,ax

  @exit:
  mov word ptr StartAddr,ax     {store starting addres}
  mov word ptr StartAddr+2,dx
end;

procedure N50;assembler;
asm int $8;iret end;
procedure N52;assembler;
asm int $a;iret end;
procedure N53;assembler;
asm int $b;iret end;
procedure N54;assembler;
asm int $c;iret end;
procedure N55;assembler;
asm int $d;iret end;
procedure N56;assembler;
asm int $e;iret end;
procedure N57;assembler;
asm int $f;iret end;

procedure SaveIm;
var
  i,j,Len,ofst:word;
  SavIMR:byte;
  Ofs_plus:word;
label Ext,Quit,exit;
begin

  asm
    cmp active,1
    je exit
    cli
  end;

  asm
    mov al,0bh
    out 20h,al
    xor cx,cx
    @here:loop @here
    in al,20h
    or al,In13h
    jne Quit
  end;

  if (In13h>0) or ((PInDos^>0) and not((In28h>0) and (byte(PInDos^)>0)))
      or (In10h>0) then goto Quit;
       {PInDos^=$100 when InDos=1, even InDos=1 if In28>0 it's safely
        to call int 21h!}
  active:=1;    {set flag for activity, so it makes reenterance impossible}
  MadeActive:=0;
  asm
    in al,21h
    mov SavIMR,al {store IMR}
    or al,00011011b
    xor cx,cx
    @here: loop @here
    out 21h,al    {disable timer and KBD and mouse}
    sti
  end;

  SaveInd;
  Detect;
  GetLogScan;
  GetCRTC;
  if boolean(NotFail) and (CreateFile) then
  begin
    if boolean(NotChain4) then SaveStatus;{useless with Chain4}
    ClearBuf;
    MakeHeader;
    WriteFile(54);
    ClearBuf;
    case ColorBits of
      4: begin GetColors16; WriteFile(64); end;
      8: begin GetColors256; WriteFile(1024); end;
    end;
    ofst:=ofset;
    for j:=MaxY downto 0 do
    begin
      i:=j;
      ofset:=ofst;
      if VESAFlag=0 then
        if j>=LineCompare then
        begin
          dec(i,LineCompare);
          ofset:=0;
        end;{j>=LineCompare}
      case ColorBits of
        4:begin
            ClearBuf;
            if VESAFlag>0 then ofset:=0;
            GetLine16(Set_Offset_And_Page(i)+ofset);
            Len:=LineSize shl 2 {linesize*4}
          end;
        8:if VESAFlag=0 then
            if not boolean(NotChain4) then
            begin                 {standart VGA}
               GetLineChain4(i);    {Chain 4}
               Len:=LineSize
            end{begin Chain4}
            else begin
              GetLinePages320(ofset+Set_Offset_And_Page(i)); {320x200 or 320x400}
              Len:=LineSize shl 2;
            end {Not Chain4}
          else begin   {some ench. modes}
            GetVESALine(Set_Offset_And_Page(i),LineSize);
            Len:=LineSize
          end;{not 320x?}

        15,16,24: {RGB}
        begin
          ofset:=Set_Offset_And_Page(i);
          Ofs_plus:=LineSize div 3;
          asm
            mov ax,Ofs_plus
            cmp ColorBits,24
            je @no_correction
            and al,0feh               {clear bit0, that ensures}
            mov byte ptr Ofs_plus,al  {Ofs_plus to be even}

            mov bx,3
            mul bx      { Len:=Ofs_plus*3/2}
            shr ax,1
           @no_correction:
            mov Len,ax                {set Len}
          end;

          GetVESALine(ofset,Ofs_plus);
          if not WriteFile(Len) then goto Ext;
          GetVESALine(ofset+Ofs_plus,Ofs_plus);
          if not WriteFile(Len) then goto Ext;
          asm
            shl Ofs_plus,1 {Ofs_plus:=Ofs_plus*2}
          end;
          GetVESALine(ofset+Ofs_plus,LineSize-Ofs_plus);
          asm
            mov ax,LineSize
            sub ax,Ofs_Plus
            cmp ColorBits,24
            je @no_correction

            mov bx,3
            mul bx        { if mode is high color}
            shr ax,1      { Len:=(LineSize-Ofs_plus)*3/2}
           @no_correction:
            mov Len,ax    { If mode is true color Len:=LineSize-Ofs_plus}
          end;
        end;{15,16,24(RGB)}
      end; {case}

      asm
        test ParamLine,2  {if bit2 is set}
        jne @NoSound      {skip this buzzing}
        in al,61h         {speaker port}
        mov bl,al         {store status of the speaker port in bl}

        mov cx,3
     @loop:
        or al,2
        out 61h,al

        mov si,68
     @w_t:
        dec si
        jne @w_t
        and al,0fdh
        out 61h,al

        mov si,40
     @w_t2:
        dec si
        jne @w_t2
        loop @loop

        mov al,bl       {restore status}
        out 61h,al
      @NoSound:
      end;

      if not WriteFile(Len) then goto Ext;
    end;{for}
    Ext:
    CloseFile;
    if boolean(NotChain4) then RestoreStatus;{the same as above}
    NextName;
  end;{If mode is detect}
  RestoreInd;

  asm
    mov al,SavIMR
    out 21h,al
    cli
  end;
  Quit:;
  active:=0;

  asm sti end;
  exit:;
end;{SaveIm}

procedure HookInt51;assembler; {this int. is KBD(IRQ1)}
asm
  pusha
  push ds
  push es
  mov ds,word ptr S_DS {set ds to the relocated Data Segment}

 @wait1:
  in al,64h
  test al,2
  jne @wait1
  mov al,0ADh {disalbe KBD}
  out 64h,al
 @wait2:
  jmp @w1
  @w1:
  in al,64h
  test al,2
  jne @wait2
  in al,60h   {read scancode}
  mov ah,al
 @wait3:
  jmp @w2
 @w2:
  in al,64h
  test al,2
  jne @wait3
  mov al,0aeh {enable KBD}
  out 64h,al

  cmp ah,70  {is scroll lock pressed?}
  jne @Go_back {no, go back}

  mov al,20h   {yes, first end ISR}
  out 20h,al

  cmp active,1
  je @exit {saving image is active so go back}
  mov MadeActive,1
  Call SaveIm  {else save it}
  jmp @exit


  @Go_back:
  int 9
  @exit:
  pop es
  pop ds
  popa
  iret
end;

procedure CheckInt13h;assembler;
asm
  pushf      {store flags}
  cmp ax,'SI'{Not used until that moment (label 'SI' is the intials of SaveImage}
  jne @No_Install_Check
  cmp bx,'PT'{indent. for uninstalling ('PT'- Picture Taker or...}
  jne @Only_Checking
  call near ptr DoUninstall
  @Only_Checking:
  mov bx,'IS'{program IS in memory}
  popf
  iret       {go back, probably could be used retf 4 as avoid prev. instr(popf)}

  @No_Install_Check:{ Normal int13 call}
  push ax    {store ax}
  push ds    {and ds}
  mov ds,word ptr S_DS {set ds to the relocated Data Segment}
  inc In13h          {if In13h isn't equal to zero, SaveIm wouldn't go}
  mov ax,word ptr Handler13h
  mov word ptr @OldInt13h,ax
  mov ax,word ptr Handler13h+2
  mov word ptr @OldInt13h+2,ax {set @OldInt13h=Handler13h for using CS}
  pop ds
  pop ax   {restore ax}

  call DWord ptr @OldInt13h {call chain INT13h}
  pushf
  pusha
  push ds
  push es
  mov ds,word ptr S_DS {set ds to the relocated Data Segment}
  dec In13h        {decrease the flag for activity of disk operation(int13h}

  cmp MadeActive,1
  jne @skp
  call SaveIm

  @skp:
  pop es
  pop ds
  popa

  popf
  retf 2        {flags are properly set}
  @OldInt13h:dd 0
end;

procedure CheckInt28h;assembler;
asm
  pusha
  push ds
  push es
  mov ds,word ptr S_DS {set ds to the relocated Data Segment}

  pushf                {store flags}
  inc In28h            {increase the flag}
  call DWord ptr [Handler28h] {call chain INT28h}
  cmp MadeActive,1
  jne @Not_Actived
  call SaveIm
  @Not_Actived:
  dec In28h        {decrease the flag for activity of an idle operation(int28h}

  pop es
  pop ds
  popa
  iret

end;

procedure CheckInt10h;assembler;
asm
  pushf
  push ax    {store ax}
  push ds    {and ds}
  mov ds,word ptr S_DS {set ds to the relocated Data Segment}

  or  ah,ah             {test set mode function}
  jne @Not_VGA_set      {not VGA set mode}
  mov LogLenFlag,0      {indicates having called Get/Set Log Scan Length}
  jmp @continue
  @Not_VGA_set:
  cmp ax,4f02h
  jne @Not_VESA_set     {not VESA set mode}
  mov LogLenFlag,0      {clear the bit indicated having called }
  jmp @continue         {int10h ax=4f06, bx=0 and continue}
  @Not_VESA_set:
  cmp ax,4f06h
  je @CheckSet
  cmp ax,4f07h
  jne @continue         {not set max scan lines}
  @CheckSet:
  or bx,bx
  jne @continue         {not set log scan length}
  or LogLenFlag,1

  @continue:
  inc In10h          {if In10h isn't equal to zero, SaveIm won't go}
  mov ax,word ptr Handler10h
  mov word ptr @OldInt10h,ax
  mov ax,word ptr Handler10h+2
  mov word ptr @OldInt10h+2,ax {set @OldInt10h=Handler10h for using cs }
  pop ds   {restore ds}
  pop ax   {restore ax}

  call DWord ptr @OldInt10h {call chain INT10}

  push ds
  mov ds,word ptr S_DS {set ds to the relocated Data Segment}

  dec In10h        {decreament flag for activity of using Video BIOS(int10h}
  jne @skp         {possible without this instruction}

  cmp MadeActive,1
  jne @skp
  pusha
  push es
  call SaveIm
  pop es
  popa
  @skp:
  pop ds

  iret
  @OldInt10h:dd 0
end;

procedure CheckWindows;assembler;
asm
  push ax    {store ax}
  push ds    {and ds}
  mov ds,word ptr S_DS {set ds to the relocated Data Segment}

  mov ax,word ptr Handler2fh
  mov word ptr @OldInt2fh,ax
  mov ax,word ptr Handler2fh+2
  mov word ptr @OldInt2fh+2,ax {set @OldInt2fh=Handler2fh for using cs }
  pop ds   {restore ds}
  pop ax   {restore ax}
  cmp ax,1605h      {Windows Ench. mode init broadcast}
  jne @Check_exit
  inc byte ptr @flag_w
  test dl,1
  jne @call_int2fh
  push ds
  push cs
  pop ds
  mov ah,9    {Shows a '$'  terminated message at DS:DX}
  mov dx,offset @Message
  int 21h
  pop ds
  inc cx            {CX<>0 so Windows should never launch (in Ench. mode)}
  iret

  @Check_exit:
  cmp ax,1606h
  jne @call_int2fh
  dec byte ptr @flag_w
  @call_int2fh:
  jmp Dword ptr @OldInt2fh
  @OldInt2fh:dd 0
  @Message:db 'Windows cannot run while SaveIm is active! Unistall this program first!$'
  @flag_w:{db 0}
end;

{$F-}
function DoUninstall:byte;

  function CompVect(Number:byte;Handler:pointer):boolean;
  var
    TmpVec:pointer;
  begin
    GetIntVec(Number,TmpVec);
    CompVect:=TmpVec=Handler;
  end;

var
  i:byte;
  Address:pointer;
  OffsetAdr:word absolute Address;

begin;
  asm
    mov ds,word ptr S_DS{set ds to the relocated Data Segment}
  end;
  DoUninstall:=2;
  if  CompVect($28,addr(CheckInt28h)) and  CompVect($13,addr(CheckInt13h))
       and CompVect($10,addr(CheckInt10h))
       and CompVect($2f,addr(CheckWindows)) then
  begin
    asm cli end;
    SetIntVec($28,Handler28h);
    SetIntVec($2f,Handler2fh);
    SetIntVec($13,Handler13h);
    SetIntVec($10,Handler10h);
    SetIRQ(8);  {set normal IRQ(IRQ0=int8)}
    Address:=P50h;
    for i:=RelocIRQ to RelocIRQ+7 do
    begin
      SetIntVec(i,Address);
      Inc(OffsetAdr,4);
    end;
    asm
      mov es,PSP
      mov ah,49h            {release memory}
      int 21h               {used by program}
      sti
    end;

    DoUninstall:=0;
  end;
end;

procedure SetEOP;assembler;
asm
  @End_of_res_part:
  lea ax,@End_of_res_part
  mov EOP,ax
end;

function Uninstall:byte;assembler;
asm
  mov ax,'SI' {ax='SI' that means not normal int13h if the program is active}
  mov bx,'PT' {if bx='PT' - uninstall}
  push ds      {store ds}
  int 13h
  pop ds       {restore ds}
  cmp bx,'IS'  {if bx='IS' the program is resident}
  je @exit
  mov al,1     {else not}
  @exit:
end;

procedure CopyData;assembler;
asm
  cld
  xor si,si
  mov di,si
  mov bx,cs
  mov dx,EOP
  shr dx,4
  add bx,dx
  inc bx
  mov es,bx            {copy data segment at the end of resident part}
  mov word ptr S_DS,bx
  mov cx,offset PSP+2
  shr cx,1
  jmp CopyIt
end;

{$F-}

label Not_Yet_Installed;
begin
  SetEOP;

  ParamLine:=Init;
  if boolean(ParamLine and 1) then
  begin {request for Unistallation}
    asm
      call UnInstall          {Check for uninstallation}
      xor ah,ah               {null the major byte}
      shl al,1                {double the result 'cause the offset is 2 bytes}
      mov si,ax
      mov dx,word ptr @adr+si {DX is set to necessary offset}
      push ds                 {possible without this instr.}
      push cs
      pop ds                  {DS:=CS}
      mov ah,9
      int 21h                 {show message at DS:DX}
      pop ds                  {possible without this instr.}
      jmp @out
      @success:db 'Successfully uninstalled.$'
      @Not_res:db 'Program is not STILL resident.$'
      @unable:db  'Unable to uninstall!$'
      @adr:dw offset @success, offset @Not_res, offset @unable
      @out:
    end;
    halt(1);
  end;
  asm
    mov ax,'SI'
    mov bx,ax
    push ds
    int 13h
    cmp bx,'IS'
    jne Not_Yet_Installed
  end;
  writeln ('Program has already been installed');
  halt(3);
  Not_Yet_Installed:

  asm   {that gets handlers 50h-57h}
    cli
    mov al,byte ptr ParamLine+1 {al=IRQ0 interrupt to be set}
    mov RelocIRQ,al             {store it for later use}
    xor cx,cx
    mov si,offset P50h
    @next_vect:
    mov ax,cx
    add al,RelocIRQ
    push ax
    push ds
    push si    {ds:si - a pointer for the handler}
    call near ptr GetIntVec{(number,pointer)}
    add si,4   {next handler}
    inc cx
    cmp cx,8h {reach the last?}
    jne @next_vect  {no, go on}
  end;
  setintvec(RelocIRQ,addr(N50));
  setintvec(RelocIRQ+1,addr(HookInt51));
  setintvec(RelocIRQ+2,addr(N52));
  setintvec(RelocIRQ+3,addr(N53));
  setintvec(RelocIRQ+4,addr(N54));
  setintvec(RelocIRQ+5,addr(N55));
  setintvec(RelocIRQ+6,addr(N56));
  setintvec(RelocIRQ+7,addr(N57));
  asm
    mov ah,34h
    int 21h
    dec bx
    mov word ptr PInDos,bx
    mov word ptr PInDos+2,es   {Get address of InDOSFlag}

    mov bx,3d4h {index port CRTC on color emulation}
    mov dx,3cch {if bit0 set-color}
    in al,dx
    test al,1
    jne @set_CRTC
    mov bx,3b4h {mono emulation}
    @set_CRTC:
    mov CRTC,bx
  end;
  In10h:=0;
  asm
    test ParamLine,2        {if bit1 is set}
    je @out                 {no sound is requested}
    push ds                 {store DS}
    push cs
    pop ds                  {DS:=CS}
    mov ah,9
    mov dx,offset @NoSnd
    int 21h                 {show message at DS:DX}
    pop ds                  {restore DS}
    jmp @out
    @NoSnd:db 'Sound is off$'
    @out:
  end;
  getintvec($28,Handler28h);
  setintvec($28,addr(CheckInt28h));
  getintvec($13,Handler13h);
  setintvec($13,addr(CheckInt13h));
  getintvec($2f,Handler2fh);
  setintvec($2f,addr(CheckWindows));
  getintvec($10,Handler10h);
  setintvec($10,addr(CheckInt10h));
  SetIRQ(RelocIRQ);

  CopyData;
{  Keep(0); { Terminate, stay resident, use MY module}
end.
